const fs = require("node:fs");
const { REST } = require("@discordjs/rest");
const { Routes } = require("discord-api-types/v9");
const {token} = require('./config.json');

const rest = new REST({ version: "9" }).setToken(token);

const commands = [];
const commandFiles = fs.readdirSync("./commands").filter((file) => file.endsWith(".js") && !file.startsWith('.'));

for (const file of commandFiles) {
  const command = require(`./commands/${file}`);
  commands.push(command.data.toJSON());
}

rest
  .put(Routes.applicationGuildCommands('898850107892596776', '587108210121506816'), { body: commands })
  .then(() => console.log(`${commands.length} commands added`))
  .catch(console.error);
